Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs	(revision 4866)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs	(revision 4867)
@@ -47,5 +47,4 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(TypeSelector));
       this.typesTreeView = new System.Windows.Forms.TreeView();
       this.imageList = new System.Windows.Forms.ImageList(this.components);
@@ -58,7 +57,7 @@
       this.setTypeParameterButton = new System.Windows.Forms.Button();
       this.typeParametersListView = new System.Windows.Forms.ListView();
+      this.columnHeader1 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
       this.descriptionTextBox = new System.Windows.Forms.TextBox();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
       this.typesGroupBox.SuspendLayout();
       this.splitContainer.Panel1.SuspendLayout();
@@ -84,8 +83,8 @@
       this.typesTreeView.ShowNodeToolTips = true;
       this.typesTreeView.Size = new System.Drawing.Size(219, 287);
-      this.typesTreeView.TabIndex = 0;
+      this.typesTreeView.TabIndex = 2;
+      this.typesTreeView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.typesTreeView_ItemDrag);
+      this.typesTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.typesTreeView_AfterSelect);
       this.typesTreeView.VisibleChanged += new System.EventHandler(this.typesTreeView_VisibleChanged);
-      this.typesTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.typesTreeView_AfterSelect);
-      this.typesTreeView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.typesTreeView_ItemDrag);
       // 
       // imageList
@@ -122,5 +121,5 @@
       this.splitContainer.Size = new System.Drawing.Size(225, 595);
       this.splitContainer.SplitterDistance = 471;
-      this.splitContainer.TabIndex = 2;
+      this.splitContainer.TabIndex = 0;
       // 
       // typeParametersSplitContainer
@@ -152,5 +151,5 @@
       this.searchLabel.Name = "searchLabel";
       this.searchLabel.Size = new System.Drawing.Size(20, 20);
-      this.searchLabel.TabIndex = 1;
+      this.searchLabel.TabIndex = 0;
       this.toolTip.SetToolTip(this.searchLabel, "Enter string to search for types");
       // 
@@ -162,5 +161,5 @@
       this.searchTextBox.Name = "searchTextBox";
       this.searchTextBox.Size = new System.Drawing.Size(193, 20);
-      this.searchTextBox.TabIndex = 2;
+      this.searchTextBox.TabIndex = 1;
       this.toolTip.SetToolTip(this.searchTextBox, "Enter string to search for types");
       this.searchTextBox.TextChanged += new System.EventHandler(this.searchTextBox_TextChanged);
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 4866)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 4867)
@@ -129,5 +129,6 @@
                   imageList.Images.Add(type.FullName, item.ItemImage);
                   typeNode.ImageIndex = imageList.Images.IndexOfKey(type.FullName);
-                } catch (Exception) { }
+                }
+                catch (Exception) { }
               }
               typeNode.SelectedImageIndex = typeNode.ImageIndex;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs	(revision 4866)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs	(revision 4867)
@@ -79,5 +79,5 @@
       this.typeSelector.Name = "typeSelector";
       this.typeSelector.Size = new System.Drawing.Size(584, 520);
-      this.typeSelector.TabIndex = 3;
+      this.typeSelector.TabIndex = 0;
       this.typeSelector.SelectedTypeChanged += new System.EventHandler(this.typeSelector_SelectedTypeChanged);
       // 